#define PWM_TOP  0xff
#define SPWM_FRQ (SYSTEM_FRQ/(PWM_TOP+1)) //31250
#define WFRQ_MIN 500
#define WFRQ_MAX 3000
#define MAX_AMP  0x1ff

#define CCR_DT   3
#define SPWM_ON  do{TIM1->EGR  = TIM_EGR_UG;  \
                    TIM1->CR1  = TIM_CR1_CEN; \
                    TIM1->BDTR = TIM_BDTR_MOE;}while(0)
#define SPWM_OFF do{TIM1->BDTR = 0; TIM1->CR1 = 0;}while(0)

//   
u16 w_size=0;
s16 b_wave [SPWM_FRQ/WFRQ_MIN]; //62

//    
//[    DMA,   ]
//[       ]
//[     CCR ]
s16 hf_wave[2][SPWM_FRQ/WFRQ_MIN][2]; //62 *4
u32 bank_dma;

//    
//   
//         
void calculate_hf_sw(int frq)
{
 int i;

 //   
 if(frq < WFRQ_MIN )       frq = WFRQ_MIN;
 else if (frq > WFRQ_MAX ) frq = WFRQ_MAX;

 //  
 w_size = SPWM_FRQ/frq;

 float y = PI*2/w_size;
 const int ss = PWM_TOP/2;

 for(i=0;i<w_size/2;i++) b_wave[i] = s16(sin(y*i)*ss);

 int tmp=i;

 for(;i<w_size;i++) b_wave[i] = -b_wave[i-tmp];
}

//           dma
//    c   deadtime
//     (0_511)    (0_1)
//         
void set_wamp(u32 amp, u32 bank=0)
{
 s16 tmp[sizeof(b_wave)/sizeof(b_wave[0])];

 //   
 if(bank > 1)     bank = 1;
 if(amp > MAX_AMP) amp = MAX_AMP;

 for(int i=0;i<w_size;i++)
 {
  tmp[i] = b_wave[i]*amp >>8;

  hf_wave[bank][i][0] = hf_wave[bank][i][1] = PWM_TOP/2 + tmp[i];

  //   deadtime  CCR
  hf_wave[bank][i][0] += CCR_DT;
  hf_wave[bank][i][1] -= CCR_DT;

  //     
  //     dt      
  if(hf_wave[bank][i][0] > PWM_TOP)
  {
   hf_wave[bank][i][1] -= hf_wave[bank][i][0] - PWM_TOP;
   hf_wave[bank][i][0]  = PWM_TOP;
  }

  //     dt      
  if(hf_wave[bank][i][1] < 0)
  {
   hf_wave[bank][i][0] -= hf_wave[bank][i][1];
   hf_wave[bank][i][1]  = 0;
  }
 }
}

//   set_wamp(..)
void change_bank(u32 bank)
{
 //     
 if(bank>1)bank = 1;

 bank_dma = bank;

 //   IFCR
 DMA1->IFCR |= DMA_IFCR_CGIF5;
 __DSB();

 //      dma
 DMA1_Channel5->CCR |= DMA_CCR_TCIE;
}
